/* Driver Digital OutPort PLC S7386-43 */

#include <conio.h>

void set_GPIO (unsigned char index, unsigned char data)
{
  outportb(0x22, index);
  outportb(0x23, data);
}

void InitPort_43 (void)
{
  set_GPIO(0x13, 0xc5);  /* unlock GPIO register for re-programming */
  set_GPIO(0x4e, 0xff);  /* set GPIO[7-0] as ouput direction */
  set_GPIO(0x4f, 0xff);  /* set GPIO[15-8] as ouput direction */
}

void SetPort_43 (unsigned int data)
{
  char PortL, PortH, Port;

  PortL = PortH = 0x00;
  if (data & 1)   PortH |= 128;
  if (data & 2)   PortL |= 128;
  if (data & 4)   PortH |= 64;
  if (data & 8)   PortL |= 64;
  if (data & 16)  PortH |= 32;
  if (data & 32)  PortL |= 32;
  if (data & 64)  PortH |= 16;
  if (data & 128) PortL |= 16;
  if (data & 256)    PortH |= 8;
  if (data & 512)    PortL |= 8;
  if (data & 1024)   PortH |= 4;
  if (data & 2048)   PortL |= 4;
  if (data & 4096)   PortH |= 2;
  if (data & 8192)   PortL |= 2;
  if (data & 16384)  PortH |= 1;
  if (data & 32768)  PortL |= 1;
  set_GPIO(0x47, PortL);
  set_GPIO(0x4d, PortH);
}

void LockPort_43 (void)
{
  set_GPIO(0x13,0x0);   /* lock GPIO register for end of programming */
}
