/* Driver Digital OutPort PLC S7386-43 */

#include <conio.h>

void set_GPIO (unsigned char index, unsigned char data)
{
  outportb(0x22, index);
  outportb(0x23, data);
}

void InitPort_50 (void)
{
  set_GPIO(0x13, 0xc5);  /* unlock GPIO register for re-programming */
  set_GPIO(0x4e, 0x0f);  /* set GPIO[7-0] as input/output direction */
  set_GPIO(0x4f ,0x0f);  /* set GPIO[15-8] as input/output direction */
}

char GetPort_50 (void)
{
  char PortL, PortH, Port;

  outportb(0x22, 0x46);  /* input data from GPIO[7-0] */
  PortL=inportb(0x23);
  outportb(0x22, 0x4c);  /* input data from GPIO[15-8] */
  PortH=inportb(0x23);
  Port = 0x00;
  if (PortL & 16)  Port |= 1;
  if (PortH & 16)  Port |= 2;
  if (PortL & 32)  Port |= 4;
  if (PortH & 32)  Port |= 8;
  if (PortL & 64)  Port |= 16;
  if (PortH & 64)  Port |= 32;
  if (PortL & 128) Port |= 64;
  if (PortH & 128) Port |= 128;
  return (Port);
}

void SetPort_50 (char data)
{
  char PortL, PortH, Port;

  PortL = PortH = 0x00;
  if (data & 1)   PortH |= 8;
  if (data & 2)   PortL |= 8;
  if (data & 4)   PortH |= 4;
  if (data & 8)   PortL |= 4;
  if (data & 16)  PortH |= 2;
  if (data & 32)  PortL |= 2;
  if (data & 64)  PortH |= 1;
  if (data & 128) PortL |= 1;
  set_GPIO(0x47, PortL);
  set_GPIO(0x4d, PortH);
}

void LockPort_50 (void)
{
  set_GPIO(0x13,0x0);   /* lock GPIO register for end of programming */
}
