/* Driver Digital InPort PLC S7386-53 */

#include <conio.h>

void set_GPIO (unsigned char index, unsigned char data)
{
  outportb(0x22, index);
  outportb(0x23, data);
}

void InitPort_53 (void)
{
  set_GPIO(0x13, 0xc5);  /* unlock GPIO register for re-programming */
  set_GPIO(0x4e, 0x00);  /* set GPIO[7-0] as input direction */
  set_GPIO(0x4f ,0x00);  /* set GPIO[15-8] as input direction */
}

unsigned int GetPort_53 (void)
{
  char PortL, PortH;
  unsigned int Port;

  outportb(0x22, 0x46);  /* input data from GPIO[7-0] */
  PortL=inportb(0x23);
  outportb(0x22, 0x4c);  /* input data from GPIO[15-8] */
  PortH=inportb(0x23);
  Port = 0x00;
  if (PortL & 16)  Port |= 1;
  if (PortH & 16)  Port |= 2;
  if (PortL & 32)  Port |= 4;
  if (PortH & 32)  Port |= 8;
  if (PortL & 64)  Port |= 16;
  if (PortH & 64)  Port |= 32;
  if (PortL & 128) Port |= 64;
  if (PortH & 128) Port |= 128;
  if (PortL & 1)   Port |= 256;
  if (PortH & 1)   Port |= 512;
  if (PortL & 2)   Port |= 1024;
  if (PortH & 2)   Port |= 2048;
  if (PortL & 4)   Port |= 4096;
  if (PortH & 4)   Port |= 8192;
  if (PortL & 8)   Port |= 16384;
  if (PortH & 8)   Port |= 32768;
  return (Port);
}

void LockPort_53 (void)
{
  set_GPIO(0x13,0x0);   /* lock GPIO register for end of programming */
}
